# define ARROW 257
# define COLMIN 258
# define QUERY 259
# define ASSIGN 260
# define EVASSIGN 261
# define IS 262
# define RELOP 263
# define NAME 264
# define GLOBVAR 265
# define VAR 266
# define STRING 267
# define NUMBER 268
# define BEMOD 269
# define BECOM 270
# define BECON 271
# define BEIMP 272
# define ENMOD 273
# define ENCOM 274
# define ENCON 275
# define ENIMP 276
# define CONSTRSEP 277
# define CONSTRAIN 278
# define STRUCVAR 279

# line 47 "pars.y"
#include <stdio.h>
#include <ctype.h>
#include "types.h"
#include "extern.h"

#define NULLTERM (termtype *)NULL
#define NULLLIST (symbollist *)NULL

/*****************************************************************************/
/* type of parser stack */
/*****************************************************************************/
typedef union {
		struct mocl {
		 modtype * modu;
		 claustype * claus;
		}		MC;
		claustype *	C;
		predtype *	P;
		termtype *	T;
		symbollist * 	S;
		intertype 	I;
		int		N;
	} YYSTYPE;

/*****************************************************************************/
/* statics*/
/*****************************************************************************/
static int	numval;		/* value delivered by scanner */
static int	modcnt	 = 1;	/* module counter */
static int	modunr   = 0;	/* current number of module */
static int      clausenr = 1;   /* current number of clause */
static int	litnr	 = 1;	/* current number of literal in clause */
static int      number_of_lits = 0;
static int	builtnr	 = 1;	/* current number of built_in in clause */
static int	poslitnr = 0;	/* number of positive literals in clause */
static int	aktsign = '+';	/* sign '-' only in tails */
static int	termsize;
static int	termdepth;
static int	max_termdepth;

static modtype    *currmodule = NULL;	/* pointer to static predecessor */
static claustype  *currclause = NULL;	/* pointer to current clause	*/
static predtype   *pp;
static termtype   *tp;
static symbollist *slp;

#define MAXDIFFVARS	1000

static int	varlist[MAXDIFFVARS];
static int	*varlist_ptr;

#define VARUSAGE(T)	\
	if (!(symbtab[T->symb].index)){ \
		*(varlist_ptr++) = T->symb; \
		symbtab[T->symb].index=varlist_ptr-varlist; \
		} 


#ifdef __STDC__
#include <stdlib.h>
#include <string.h>
#else
#include <malloc.h>
#include <memory.h>
#endif

#include <values.h>

#ifdef __cplusplus

#ifndef yyerror
	void yyerror(const char *);
#endif

#ifndef yylex
#ifdef __EXTERN_C__
	extern "C" { int yylex(void); }
#else
	int yylex(void);
#endif
#endif
	int yyparse(void);

#endif
#define yyclearin yychar = -1
#define yyerrok yyerrflag = 0
extern int yychar;
extern int yyerrflag;
YYSTYPE yylval;
YYSTYPE yyval;
typedef int yytabelem;
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 150
#endif
#if YYMAXDEPTH > 0
int yy_yys[YYMAXDEPTH], *yys = yy_yys;
YYSTYPE yy_yyv[YYMAXDEPTH], *yyv = yy_yyv;
#else	/* user does initial allocation */
int *yys;
YYSTYPE *yyv;
#endif
static int yymaxdepth = YYMAXDEPTH;
# define YYERRCODE 256

# line 698 "pars.y"


#include "lex.yy.c"
#include "init.c"

/***********************************************************************/
/* yyerror and additional functions*/
/* orig. from yaccsed.script*/
/***********************************************************************/
yyerror(s)  /* Verbesserte Fehlermeldungen */
register char *s; {  /*nach Schreiner*/
extern int yynerrs;
static int list = 0;
if (!list) {
  printf("[error %d] ",yynerrs+1); yywhere();
  if (list=s[strlen(s)-1]==':') fputs(s,stdout);
    else puts(s);
  } else if (*s!='\n') putchar(' '),fputs(s,stdout);
    else putchar('\n'),list=0;
}

#ifdef hpux
extern unsigned char yytext[];
#else
extern char yytext[];
#endif

extern int yyleng,yylineno;
yywhere() {  /* Fehlerplatzierung durch Bezug auf yytext */
register int colon=0;  /*nach Schreiner*/
if (yylineno>0) {
  if (colon) fputs(", ",stdout);
   printf("line %d",yylineno-((*yytext=='\n')||(!*yytext)));
   colon=1;
  }
switch (*yytext) {
  case '\0':
  case '\n': break;
  default: if (colon) putchar(' ');
    printf("near \"%.*s\"",yyleng>20 ? 20 :
	   yytext[yyleng-1]=='\n' ? yyleng-1 : yyleng,yytext);
    colon=1;
  }
if (colon) fputs(": ",stdout);
}

static const yytabelem yyexca[] ={
-1, 1,
	0, -1,
	-2, 0,
-1, 4,
	0, 3,
	-2, 6,
-1, 11,
	257, 22,
	277, 20,
	46, 20,
	-2, 0,
-1, 13,
	277, 21,
	46, 21,
	-2, 73,
-1, 16,
	278, 49,
	61, 49,
	-2, 65,
-1, 17,
	278, 52,
	61, 52,
	-2, 66,
-1, 19,
	278, 54,
	61, 54,
	-2, 40,
-1, 23,
	278, 50,
	61, 50,
	-2, 64,
-1, 30,
	277, 13,
	46, 13,
	-2, 11,
-1, 63,
	277, 28,
	46, 28,
	-2, 0,
-1, 66,
	257, 26,
	-2, 73,
-1, 67,
	257, 22,
	-2, 0,
-1, 69,
	257, 27,
	-2, 73,
-1, 106,
	93, 45,
	41, 45,
	-2, 0,
-1, 119,
	277, 32,
	46, 32,
	-2, 73,
-1, 121,
	277, 33,
	46, 33,
	-2, 73,
-1, 125,
	278, 55,
	61, 55,
	-2, 41,
	};
# define YYNPROD 82
# define YYLAST 376
static const yytabelem yyact[]={

    24,    28,   116,    50,    60,    25,    24,    28,    38,    40,
    41,    25,    39,    33,    46,    44,    33,    45,   100,    47,
    30,   105,    24,   113,    99,   126,    96,    25,    24,   133,
    22,    94,    57,    25,    46,    44,    91,    45,   112,    47,
    58,    97,    43,    46,    24,    88,    93,   115,    47,    25,
    24,    28,    90,    46,    44,    25,    45,    28,    47,    62,
   104,    46,    44,   138,    45,    24,    47,   134,   125,    72,
    25,    74,    42,    28,    14,    80,    89,     3,    34,    28,
   110,    34,     7,    87,    36,   108,    15,    64,    92,    31,
    37,    61,    15,    29,     6,    28,    71,    63,     2,     1,
    95,    28,    59,   114,    11,   103,     8,    18,    15,     5,
     4,   106,     0,     0,    15,     0,     0,     9,   109,   117,
   111,    98,     0,     0,   102,   123,     0,     0,   106,     0,
    15,    67,    67,    67,   106,     0,    15,   124,     0,     0,
     0,   128,     0,   132,    92,   130,   135,   131,   136,   137,
   129,    65,    68,    70,     0,   106,     0,   106,   106,   118,
   120,   122,     0,     0,     0,     0,   107,     0,     0,     0,
     0,     0,     0,     0,    78,    20,    75,    26,    76,     0,
    78,    20,    75,    26,    76,     0,     0,     0,     0,    27,
     0,     0,     0,     0,     0,    27,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    35,     0,    32,    35,     0,     0,    13,    10,     0,    12,
    49,     0,    55,     0,    19,    20,    16,    26,    23,     0,
    19,    20,    16,    26,    23,    48,   101,   127,   121,    27,
     0,     0,     0,     0,   119,    27,    19,    20,    16,    26,
    23,     0,    19,    20,    16,    26,    23,     0,     0,     0,
    69,    27,     0,     0,     0,     0,    66,    27,    19,    20,
    16,    26,    23,    77,    19,    20,    16,    26,    23,     0,
    17,    55,     0,    27,     0,     0,     0,     0,     0,    27,
    20,    53,     0,    52,     0,     0,     0,     0,    54,    54,
    21,     0,     0,     0,     0,    17,     0,    17,    17,    17,
    17,     0,     0,    54,     0,    54,     0,    54,    54,    54,
    54,    54,    54,     0,     0,    51,    56,     0,     0,     0,
     0,     0,     0,     0,     0,    17,     0,     0,    17,     0,
    73,     0,    79,     0,    81,    82,    83,    84,    85,    86,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,    17,    17,    17 };
static const yytabelem yypact[]={

-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,   -40,-10000000,-10000000,  -237,
-10000000,   -46,-10000000,-10000000,-10000000,  -256,  -250,  -251,-10000000,    32,
   -49,   -28,   -58,-10000000,    25,    25,-10000000,-10000000,   -53,  -273,
-10000000,   -34,-10000000,    10,     4,   -34,   -34,-10000000,    29,    25,
   -84,    25,-10000000,    25,    25,    25,    25,    25,    25,-10000000,
   -16,    11,-10000000,-10000000,-10000000,-10000000,-10000000,   -84,-10000000,     0,
   -50,   -34,-10000000,   -20,   -34,-10000000,-10000000,   -43,-10000000,-10000000,
-10000000,-10000000,-10000000,    19,-10000000,-10000000,-10000000,-10000000,    20,    19,
   -90,    -8,     1,     1,-10000000,-10000000,    19,   -84,-10000000,   -84,
-10000000,   -55,   -21,-10000000,-10000000,     3,  -276,   -90,-10000000,   -12,
   -18,   -34,-10000000,   -90,-10000000,    27,   -19,-10000000,-10000000,-10000000,
   -84,-10000000,-10000000,   -84,   -84,   -50,   -50,   -64,-10000000,-10000000,
-10000000,-10000000,-10000000,    26,   -90,-10000000,   -90,   -90,-10000000,-10000000,
-10000000,-10000000,-10000000,-10000000,-10000000,    22,-10000000,-10000000,-10000000 };
static const yytabelem yypgo[]={

     0,    77,   110,   109,   107,    97,    74,   117,    59,   106,
   102,    31,   100,   300,    30,    21,   273,    36,    26,    99,
    98,    94,    93,    91,    89,    87,    84,    32,    83,    80,
    76 };
static const yytabelem yyr1[]={

     0,    20,    19,     1,     1,     2,    21,    22,     3,    10,
    10,    23,     9,     9,    24,     9,    25,     9,    26,     9,
     9,     9,     7,     7,     7,     7,     7,     7,     8,     8,
     8,     8,     8,     8,     5,     5,     5,     5,     5,     5,
     6,     6,    11,    11,    12,    15,    15,    15,    15,    14,
    14,    14,    14,    14,    14,    14,    14,    14,    17,    17,
    17,    18,    16,    16,    13,    13,    13,    13,    13,    13,
    13,    13,    13,    13,     4,    28,     4,    29,     4,    30,
     4,    27 };
static const yytabelem yyr2[]={

     0,     1,     5,     2,     5,     3,     1,     1,    11,     1,
     5,     1,     9,     5,     1,     7,     1,     9,     1,     7,
     2,     3,     2,     7,     7,     7,     6,     6,     2,     7,
     7,     7,     6,     6,     3,     5,     7,     7,     7,     2,
     3,    11,     2,     7,     7,     2,     7,     7,     3,     3,
     3,     3,     2,     3,     3,    11,     9,     5,     3,     7,
     7,     7,     3,     9,     3,     3,     2,     7,     7,     7,
     7,     7,     5,     3,     7,     1,     9,     1,    11,     1,
     9,     1 };
static const yytabelem yychk[]={

-10000000,   -19,   -20,    -1,    -2,    -3,   -21,    -1,    -9,    -7,
   257,    -5,   259,   256,    -6,   126,   266,   -16,    -4,   264,
   265,   -13,   -14,   268,    40,    45,   267,   279,    91,   -22,
   257,   -24,   258,    59,   124,   256,   -26,    -6,   264,   262,
   260,   261,    40,    91,    43,    45,    42,    47,   263,   278,
    61,   -13,   268,   266,   -16,   256,   -13,   -27,    93,   -10,
   277,   -23,    -8,    -5,   -25,    -7,   256,    -5,    -7,   256,
    -7,    -8,    40,   -13,   -14,   266,   268,   -16,   264,   -13,
   -27,   -13,   -13,   -13,   -13,   -13,   -13,   -28,    61,   -30,
    41,   -17,   -14,    46,   -11,   -12,   -18,    91,    -8,    44,
    38,   256,    -8,   -27,    40,   -15,   -14,   256,    93,   -14,
   -29,   -14,    93,    44,   124,    44,   278,   -15,    -8,   256,
    -8,   256,    -8,   -15,   -27,    41,    44,   256,   -14,   -17,
   -14,   -11,   -18,    93,    41,   -15,   -15,   -15,    41 };
static const yytabelem yydef[]={

     1,    -2,     6,     2,    -2,     5,     0,     4,     7,     0,
    14,    -2,    18,    -2,    34,     0,    -2,    -2,    39,    -2,
    62,     0,     0,    -2,     0,     0,    51,    53,    81,     9,
    -2,     0,    16,     0,     0,     0,     0,    35,    40,     0,
     0,     0,    81,     0,     0,     0,     0,     0,     0,    75,
    79,     0,    64,    65,    66,    73,    72,     0,    57,     0,
     0,     0,    15,    -2,     0,    23,    -2,    -2,    24,    -2,
    25,    19,    81,    36,    37,    49,    50,    52,    54,    38,
     0,     0,    68,    69,    70,    71,    74,     0,    77,     0,
    67,     0,    58,     8,    10,    42,     0,     0,    12,     0,
     0,     0,    17,     0,    81,     0,    -2,    48,    63,    76,
     0,    80,    56,     0,     0,     0,     0,     0,    29,    -2,
    30,    -2,    31,     0,     0,    -2,     0,     0,    78,    59,
    60,    43,    44,    61,    41,     0,    46,    47,    55 };
typedef struct
#ifdef __cplusplus
	yytoktype
#endif
{ char *t_name; int t_val; } yytoktype;
#ifndef YYDEBUG
#	define YYDEBUG	0	/* don't allow debugging */
#endif

#if YYDEBUG

yytoktype yytoks[] =
{
	"ARROW",	257,
	"COLMIN",	258,
	"QUERY",	259,
	"ASSIGN",	260,
	"EVASSIGN",	261,
	"IS",	262,
	"RELOP",	263,
	"NAME",	264,
	"GLOBVAR",	265,
	"VAR",	266,
	"STRING",	267,
	"NUMBER",	268,
	"BEMOD",	269,
	"BECOM",	270,
	"BECON",	271,
	"BEIMP",	272,
	"ENMOD",	273,
	"ENCOM",	274,
	"ENCON",	275,
	"ENIMP",	276,
	"CONSTRSEP",	277,
	"CONSTRAIN",	278,
	"STRUCVAR",	279,
	".",	46,
	";",	59,
	",",	44,
	"|",	124,
	"~",	126,
	"[",	91,
	"]",	93,
	"(",	40,
	")",	41,
	"+",	43,
	"-",	45,
	"*",	42,
	"/",	47,
	"-unknown-",	-1	/* ends search */
};

char * yyreds[] =
{
	"-no such reduction-",
	"mploprogram : /* empty */",
	"mploprogram : modules",
	"modules : module",
	"modules : module modules",
	"module : clause",
	"clause : /* empty */",
	"clause : synclause",
	"clause : synclause opt_constraints '.'",
	"opt_constraints : /* empty */",
	"opt_constraints : CONSTRSEP constraints",
	"synclause : head ARROW",
	"synclause : head ARROW tail",
	"synclause : head ARROW",
	"synclause : ARROW",
	"synclause : ARROW tail",
	"synclause : literal COLMIN",
	"synclause : literal COLMIN tail",
	"synclause : QUERY",
	"synclause : QUERY tail",
	"synclause : literal",
	"synclause : error",
	"head : literal",
	"head : literal ';' head",
	"head : literal '|' head",
	"head : literal error head",
	"head : literal ';' error",
	"head : literal '|' error",
	"tail : literal",
	"tail : literal ',' tail",
	"tail : literal '&' tail",
	"tail : literal error tail",
	"tail : literal ',' error",
	"tail : literal '&' error",
	"literal : predicate",
	"literal : '~' predicate",
	"literal : VAR IS numexpr",
	"literal : glvar ASSIGN term",
	"literal : glvar EVASSIGN numexpr",
	"literal : binexpr",
	"predicate : NAME",
	"predicate : NAME '(' inctermdepth terms ')'",
	"constraints : constraint",
	"constraints : constraint ',' constraints",
	"constraint : conslist CONSTRAIN conslist",
	"terms : term",
	"terms : term ',' terms",
	"terms : term error terms",
	"terms : error",
	"term : VAR",
	"term : NUMBER",
	"term : STRING",
	"term : glvar",
	"term : STRUCVAR",
	"term : NAME",
	"term : NAME '(' inctermdepth terms ')'",
	"term : '[' inctermdepth list ']'",
	"term : '[' ']'",
	"list : term",
	"list : term ',' list",
	"list : term '|' term",
	"conslist : '[' terms ']'",
	"glvar : GLOBVAR",
	"glvar : GLOBVAR '[' numexpr ']'",
	"numexpr : NUMBER",
	"numexpr : VAR",
	"numexpr : glvar",
	"numexpr : '(' numexpr ')'",
	"numexpr : numexpr '+' numexpr",
	"numexpr : numexpr '-' numexpr",
	"numexpr : numexpr '*' numexpr",
	"numexpr : numexpr '/' numexpr",
	"numexpr : '-' numexpr",
	"numexpr : error",
	"binexpr : numexpr RELOP numexpr",
	"binexpr : term CONSTRAIN",
	"binexpr : term CONSTRAIN term",
	"binexpr : term '=' '='",
	"binexpr : term '=' '=' term",
	"binexpr : term '='",
	"binexpr : term '=' term",
	"inctermdepth : /* empty */",
};
#endif /* YYDEBUG */
# line	1 "/usr/ccs/bin/yaccpar"
/*
 * Copyright (c) 1993 by Sun Microsystems, Inc.
 */

#pragma ident	"@(#)yaccpar	6.14	97/01/16 SMI"

/*
** Skeleton parser driver for yacc output
*/

/*
** yacc user known macros and defines
*/
#define YYERROR		goto yyerrlab
#define YYACCEPT	return(0)
#define YYABORT		return(1)
#define YYBACKUP( newtoken, newvalue )\
{\
	if ( yychar >= 0 || ( yyr2[ yytmp ] >> 1 ) != 1 )\
	{\
		yyerror( "syntax error - cannot backup" );\
		goto yyerrlab;\
	}\
	yychar = newtoken;\
	yystate = *yyps;\
	yylval = newvalue;\
	goto yynewstate;\
}
#define YYRECOVERING()	(!!yyerrflag)
#define YYNEW(type)	malloc(sizeof(type) * yynewmax)
#define YYCOPY(to, from, type) \
	(type *) memcpy(to, (char *) from, yymaxdepth * sizeof (type))
#define YYENLARGE( from, type) \
	(type *) realloc((char *) from, yynewmax * sizeof(type))
#ifndef YYDEBUG
#	define YYDEBUG	1	/* make debugging available */
#endif

/*
** user known globals
*/
int yydebug;			/* set to 1 to get debugging */

/*
** driver internal defines
*/
#define YYFLAG		(-10000000)

/*
** global variables used by the parser
*/
YYSTYPE *yypv;			/* top of value stack */
int *yyps;			/* top of state stack */

int yystate;			/* current state */
int yytmp;			/* extra var (lasts between blocks) */

int yynerrs;			/* number of errors */
int yyerrflag;			/* error recovery flag */
int yychar;			/* current input token number */



#ifdef YYNMBCHARS
#define YYLEX()		yycvtok(yylex())
/*
** yycvtok - return a token if i is a wchar_t value that exceeds 255.
**	If i<255, i itself is the token.  If i>255 but the neither 
**	of the 30th or 31st bit is on, i is already a token.
*/
#if defined(__STDC__) || defined(__cplusplus)
int yycvtok(int i)
#else
int yycvtok(i) int i;
#endif
{
	int first = 0;
	int last = YYNMBCHARS - 1;
	int mid;
	wchar_t j;

	if(i&0x60000000){/*Must convert to a token. */
		if( yymbchars[last].character < i ){
			return i;/*Giving up*/
		}
		while ((last>=first)&&(first>=0)) {/*Binary search loop*/
			mid = (first+last)/2;
			j = yymbchars[mid].character;
			if( j==i ){/*Found*/ 
				return yymbchars[mid].tvalue;
			}else if( j<i ){
				first = mid + 1;
			}else{
				last = mid -1;
			}
		}
		/*No entry in the table.*/
		return i;/* Giving up.*/
	}else{/* i is already a token. */
		return i;
	}
}
#else/*!YYNMBCHARS*/
#define YYLEX()		yylex()
#endif/*!YYNMBCHARS*/

/*
** yyparse - return 0 if worked, 1 if syntax error not recovered from
*/
#if defined(__STDC__) || defined(__cplusplus)
int yyparse(void)
#else
int yyparse()
#endif
{
	register YYSTYPE *yypvt = 0;	/* top of value stack for $vars */

#if defined(__cplusplus) || defined(lint)
/*
	hacks to please C++ and lint - goto's inside
	switch should never be executed
*/
	static int __yaccpar_lint_hack__ = 0;
	switch (__yaccpar_lint_hack__)
	{
		case 1: goto yyerrlab;
		case 2: goto yynewstate;
	}
#endif

	/*
	** Initialize externals - yyparse may be called more than once
	*/
	yypv = &yyv[-1];
	yyps = &yys[-1];
	yystate = 0;
	yytmp = 0;
	yynerrs = 0;
	yyerrflag = 0;
	yychar = -1;

#if YYMAXDEPTH <= 0
	if (yymaxdepth <= 0)
	{
		if ((yymaxdepth = YYEXPAND(0)) <= 0)
		{
			yyerror("yacc initialization error");
			YYABORT;
		}
	}
#endif

	{
		register YYSTYPE *yy_pv;	/* top of value stack */
		register int *yy_ps;		/* top of state stack */
		register int yy_state;		/* current state */
		register int  yy_n;		/* internal state number info */
	goto yystack;	/* moved from 6 lines above to here to please C++ */

		/*
		** get globals into registers.
		** branch to here only if YYBACKUP was called.
		*/
	yynewstate:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;
		goto yy_newstate;

		/*
		** get globals into registers.
		** either we just started, or we just finished a reduction
		*/
	yystack:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;

		/*
		** top of for (;;) loop while no reductions done
		*/
	yy_stack:
		/*
		** put a state and value onto the stacks
		*/
#if YYDEBUG
		/*
		** if debugging, look up token value in list of value vs.
		** name pairs.  0 and negative (-1) are special values.
		** Note: linear search is used since time is not a real
		** consideration while debugging.
		*/
		if ( yydebug )
		{
			register int yy_i;

			printf( "State %d, token ", yy_state );
			if ( yychar == 0 )
				printf( "end-of-file\n" );
			else if ( yychar < 0 )
				printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ++yy_ps >= &yys[ yymaxdepth ] )	/* room on stack? */
		{
			/*
			** reallocate and recover.  Note that pointers
			** have to be reset, or bad things will happen
			*/
			int yyps_index = (yy_ps - yys);
			int yypv_index = (yy_pv - yyv);
			int yypvt_index = (yypvt - yyv);
			int yynewmax;
#ifdef YYEXPAND
			yynewmax = YYEXPAND(yymaxdepth);
#else
			yynewmax = 2 * yymaxdepth;	/* double table size */
			if (yymaxdepth == YYMAXDEPTH)	/* first time growth */
			{
				char *newyys = (char *)YYNEW(int);
				char *newyyv = (char *)YYNEW(YYSTYPE);
				if (newyys != 0 && newyyv != 0)
				{
					yys = YYCOPY(newyys, yys, int);
					yyv = YYCOPY(newyyv, yyv, YYSTYPE);
				}
				else
					yynewmax = 0;	/* failed */
			}
			else				/* not first time */
			{
				yys = YYENLARGE(yys, int);
				yyv = YYENLARGE(yyv, YYSTYPE);
				if (yys == 0 || yyv == 0)
					yynewmax = 0;	/* failed */
			}
#endif
			if (yynewmax <= yymaxdepth)	/* tables not expanded */
			{
				yyerror( "yacc stack overflow" );
				YYABORT;
			}
			yymaxdepth = yynewmax;

			yy_ps = yys + yyps_index;
			yy_pv = yyv + yypv_index;
			yypvt = yyv + yypvt_index;
		}
		*yy_ps = yy_state;
		*++yy_pv = yyval;

		/*
		** we have a new state - find out what to do
		*/
	yy_newstate:
		if ( ( yy_n = yypact[ yy_state ] ) <= YYFLAG )
			goto yydefault;		/* simple state */
#if YYDEBUG
		/*
		** if debugging, need to mark whether new token grabbed
		*/
		yytmp = yychar < 0;
#endif
		if ( ( yychar < 0 ) && ( ( yychar = YYLEX() ) < 0 ) )
			yychar = 0;		/* reached EOF */
#if YYDEBUG
		if ( yydebug && yytmp )
		{
			register int yy_i;

			printf( "Received token " );
			if ( yychar == 0 )
				printf( "end-of-file\n" );
			else if ( yychar < 0 )
				printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ( ( yy_n += yychar ) < 0 ) || ( yy_n >= YYLAST ) )
			goto yydefault;
		if ( yychk[ yy_n = yyact[ yy_n ] ] == yychar )	/*valid shift*/
		{
			yychar = -1;
			yyval = yylval;
			yy_state = yy_n;
			if ( yyerrflag > 0 )
				yyerrflag--;
			goto yy_stack;
		}

	yydefault:
		if ( ( yy_n = yydef[ yy_state ] ) == -2 )
		{
#if YYDEBUG
			yytmp = yychar < 0;
#endif
			if ( ( yychar < 0 ) && ( ( yychar = YYLEX() ) < 0 ) )
				yychar = 0;		/* reached EOF */
#if YYDEBUG
			if ( yydebug && yytmp )
			{
				register int yy_i;

				printf( "Received token " );
				if ( yychar == 0 )
					printf( "end-of-file\n" );
				else if ( yychar < 0 )
					printf( "-none-\n" );
				else
				{
					for ( yy_i = 0;
						yytoks[yy_i].t_val >= 0;
						yy_i++ )
					{
						if ( yytoks[yy_i].t_val
							== yychar )
						{
							break;
						}
					}
					printf( "%s\n", yytoks[yy_i].t_name );
				}
			}
#endif /* YYDEBUG */
			/*
			** look through exception table
			*/
			{
				register const int *yyxi = yyexca;

				while ( ( *yyxi != -1 ) ||
					( yyxi[1] != yy_state ) )
				{
					yyxi += 2;
				}
				while ( ( *(yyxi += 2) >= 0 ) &&
					( *yyxi != yychar ) )
					;
				if ( ( yy_n = yyxi[1] ) < 0 )
					YYACCEPT;
			}
		}

		/*
		** check for syntax error
		*/
		if ( yy_n == 0 )	/* have an error */
		{
			/* no worry about speed here! */
			switch ( yyerrflag )
			{
			case 0:		/* new error */
				yyerror( "syntax error" );
				goto skip_init;
			yyerrlab:
				/*
				** get globals into registers.
				** we have a user generated syntax type error
				*/
				yy_pv = yypv;
				yy_ps = yyps;
				yy_state = yystate;
			skip_init:
				yynerrs++;
				/* FALLTHRU */
			case 1:
			case 2:		/* incompletely recovered error */
					/* try again... */
				yyerrflag = 3;
				/*
				** find state where "error" is a legal
				** shift action
				*/
				while ( yy_ps >= yys )
				{
					yy_n = yypact[ *yy_ps ] + YYERRCODE;
					if ( yy_n >= 0 && yy_n < YYLAST &&
						yychk[yyact[yy_n]] == YYERRCODE)					{
						/*
						** simulate shift of "error"
						*/
						yy_state = yyact[ yy_n ];
						goto yy_stack;
					}
					/*
					** current state has no shift on
					** "error", pop stack
					*/
#if YYDEBUG
#	define _POP_ "Error recovery pops state %d, uncovers state %d\n"
					if ( yydebug )
						printf( _POP_, *yy_ps,
							yy_ps[-1] );
#	undef _POP_
#endif
					yy_ps--;
					yy_pv--;
				}
				/*
				** there is no state on stack with "error" as
				** a valid shift.  give up.
				*/
				YYABORT;
			case 3:		/* no shift yet; eat a token */
#if YYDEBUG
				/*
				** if debugging, look up token in list of
				** pairs.  0 and negative shouldn't occur,
				** but since timing doesn't matter when
				** debugging, it doesn't hurt to leave the
				** tests here.
				*/
				if ( yydebug )
				{
					register int yy_i;

					printf( "Error recovery discards " );
					if ( yychar == 0 )
						printf( "token end-of-file\n" );
					else if ( yychar < 0 )
						printf( "token -none-\n" );
					else
					{
						for ( yy_i = 0;
							yytoks[yy_i].t_val >= 0;
							yy_i++ )
						{
							if ( yytoks[yy_i].t_val
								== yychar )
							{
								break;
							}
						}
						printf( "token %s\n",
							yytoks[yy_i].t_name );
					}
				}
#endif /* YYDEBUG */
				if ( yychar == 0 )	/* reached EOF. quit */
					YYABORT;
				yychar = -1;
				goto yy_newstate;
			}
		}/* end if ( yy_n == 0 ) */
		/*
		** reduction by production yy_n
		** put stack tops, etc. so things right after switch
		*/
#if YYDEBUG
		/*
		** if debugging, print the string that is the user's
		** specification of the reduction which is just about
		** to be done.
		*/
		if ( yydebug )
			printf( "Reduce by (%d) \"%s\"\n",
				yy_n, yyreds[ yy_n ] );
#endif
		yytmp = yy_n;			/* value to switch over */
		yypvt = yy_pv;			/* $vars top of value stack */
		/*
		** Look in goto table for next state
		** Sorry about using yy_state here as temporary
		** register variable, but why not, if it works...
		** If yyr2[ yy_n ] doesn't have the low order bit
		** set, then there is no action to be done for
		** this reduction.  So, no saving & unsaving of
		** registers done.  The only difference between the
		** code just after the if and the body of the if is
		** the goto yy_stack in the body.  This way the test
		** can be made before the choice of what to do is needed.
		*/
		{
			/* length of production doubled with extra bit */
			register int yy_len = yyr2[ yy_n ];

			if ( !( yy_len & 01 ) )
			{
				yy_len >>= 1;
				yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
				yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
					*( yy_ps -= yy_len ) + 1;
				if ( yy_state >= YYLAST ||
					yychk[ yy_state =
					yyact[ yy_state ] ] != -yy_n )
				{
					yy_state = yyact[ yypgo[ yy_n ] ];
				}
				goto yy_stack;
			}
			yy_len >>= 1;
			yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
			yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
				*( yy_ps -= yy_len ) + 1;
			if ( yy_state >= YYLAST ||
				yychk[ yy_state = yyact[ yy_state ] ] != -yy_n )
			{
				yy_state = yyact[ yypgo[ yy_n ] ];
			}
		}
					/* save until reenter driver code */
		yystate = yy_state;
		yyps = yy_ps;
		yypv = yy_pv;
	}
	/*
	** code supplied by user is placed in this switch
	*/
	switch( yytmp )
	{
		
case 1:
# line 119 "pars.y"
{ 
		 init_symb(); /* initialize symboltable, enter built-ins */
		 matrix = init_mod(enter_token("main_"));
		 } break;
case 2:
# line 124 "pars.y"
{
		 if (errors) {
		   fprintf(stderr,"parsing: %d errors occurred\n",errors);
		   return(1);
		   }
		 matrix->c_list  = yypvt[-0].MC.claus;
		    /* default query is standard */
		 prefix_query(matrix);
		 nr_clauses = clausenr-1;	/* save in global variable */
		 return(0);
		 } break;
case 4:
# line 140 "pars.y"
{
		 if (yypvt[-1].MC.modu) {
		    yypvt[-1].MC.modu->next = yypvt[-0].MC.modu;
		    yypvt[-1].MC.claus = yypvt[-0].MC.claus;
		    }
		 else {
		    yypvt[-1].MC.claus->next = yypvt[-0].MC.claus;
		    yypvt[-1].MC.modu = yypvt[-0].MC.modu;
		    }
		 yyval.MC.claus = yypvt[-1].MC.claus;
		 yyval.MC.modu = yypvt[-1].MC.modu;
		 } break;
case 5:
# line 156 "pars.y"
{
		 yyval.MC.modu	= NULL;
		 yyval.MC.claus 	= yypvt[-0].C;
		 } break;
case 6:
# line 163 "pars.y"
{ /* syntax rule only for semantic actions for/after clause */
		 yyval.C = currclause = newclause();
		 yyval.C->modul	= currmodule;
		 yyval.C->clnr	= clausenr;
		 yyval.C->lineno	= yylineno;
		 yyval.C->delpos	= PFACT;	/* default */
		 yyval.C->parsed_rule_type = PFACT;
		 yyval.C->poslits  =0;
		 yyval.C->max_termsize  =0;
		 yyval.C->max_termdepth  =0;
		 yyval.C->order 	= clausenr++;	
		 yyval.C->fann	= NULL;
		 yyval.C->next	= NULL;
		 builtnr	= 1;
		 litnr		= 1;
		 number_of_lits = 0;
		 poslitnr	= 0;
		 max_termdepth	=0;
		 termdepth	=0;
		 termsize	=0;
		 varlist_ptr	= varlist;
		 /* needed for '@ClauseReorderingStartingPoint' */
		 curr_clausenr = clausenr;
		 } break;
case 7:
# line 188 "pars.y"
{
		 yyerrok;
		 if (litnr > maxlit) maxlit = litnr;
		 if (yypvt[-1].C->delpos<0) nofanning = 1;
		 yypvt[-1].C->p_list	 = yypvt[-0].P;
		 yypvt[-0].P->kp	 = yypvt[-1].C;
		 yypvt[-1].C->nr_built = builtnr-1;
		 yypvt[-1].C->nr_lits	 = litnr-1;
		 yypvt[-1].C->clr_nr_lits = litnr- 1 - number_of_lits;	   
		 yypvt[-1].C->poslits	 = poslitnr;
		 yypvt[-1].C->nrvars	 = varlist_ptr - varlist;
		/* clean up the symbol table */
		while (varlist_ptr > varlist){
			symbtab[*(--varlist_ptr)].index=0;
			}

		/* initialize the decrements of inferences and depth */
		yypvt[-1].C->dinf     = yypvt[-1].C->nr_lits - yypvt[-1].C->nr_built - 1;
		if(yypvt[-1].C->dinf > 0) {
			yypvt[-1].C->ddepth = 1;
			}
                else {
		 	yypvt[-1].C->ddepth = 0;
			}


		 /* debugging of termdepth-size */
		 /* printf("termdepth=%d termsize=%d nrvars=%d\n",
		 	$<C>1->max_termdepth,
		 	$<C>1->max_termsize,
		 	$<C>1->nrvars); */ /* bitte so lassen */
		 } break;
case 8:
# line 221 "pars.y"
{
		 yypvt[-4].C->constr = yypvt[-1].P;	       
		 if (yypvt[-4].C->constr != NULL) {
		   yypvt[-4].C->flag_constraints = 1;
		 } else {
		   yypvt[-4].C->flag_constraints = 0;
		 }
		 if (poslitnr > 1) ishorn = 0;
		 } break;
case 9:
# line 233 "pars.y"
{ /* empty */
		 yyval.P = NULL;
                 } break;
case 10:
# line 237 "pars.y"
{
		 yyval.P = yypvt[-0].P;
		 } break;
case 11:
# line 244 "pars.y"
{
                 aktsign = '-';
                 currclause->delpos = litnr;
		 currclause->parsed_rule_type = 0;
                 } break;
case 12:
# line 250 "pars.y"
{
                 aktsign = '+';
                 /* last(head) -> first(tail) */
                 for (pp = yypvt[-3].P ; pp->next ; pp = pp->next) ;
                 pp->next = yypvt[-0].P;
                 } break;
case 13:
# line 257 "pars.y"
{
                 currclause->delpos = litnr;
		 currclause->parsed_rule_type = 0;
                 } break;
case 14:
# line 262 "pars.y"
{
		 currclause->delpos = litnr;
		 currclause->parsed_rule_type = 0;
		 /* default query has index 0 */
		 yyval.P = init_pred(NULLTERM,0);
		 poslitnr = 1;
		 aktsign = '-';
		 if (!inwasm_flags.oldclausreord) {
		   /* do not count __query Literal */		   
		   number_of_lits++;
		 }
		 } break;
case 15:
# line 275 "pars.y"
{
		 aktsign = '+';
		 yypvt[-1].P->next = yypvt[-0].P;
		 yyval.P = yypvt[-1].P;
		 } break;
case 16:
# line 281 "pars.y"
{
		 aktsign = '-';
		 } break;
case 17:
# line 285 "pars.y"
{
		 aktsign = '+';
		 currclause->delpos = PRULE;
		 currclause->parsed_rule_type = PRULE;
		 yypvt[-3].P->next = yypvt[-0].P;
		 } break;
case 18:
# line 292 "pars.y"
{
		 /* default query has index 0 */
		 yyval.P = init_pred(NULLTERM,0);
		 poslitnr = 1;
		 aktsign = '-';
		 if (!inwasm_flags.oldclausreord) {
		   /* do not count __query Literal */
		   number_of_lits++;
		 }
		 } break;
case 19:
# line 303 "pars.y"
{
		 aktsign = '+';
		 currclause->delpos = PQUERY;
		 currclause->parsed_rule_type = PQUERY;	     
		 yypvt[-1].P->next = yypvt[-0].P;
		 yyval.P = yypvt[-1].P;
		 } break;
case 21:
# line 312 "pars.y"
{
		 yyerrok;
		 yyval.P = NULL;
		 } break;
case 23:
# line 321 "pars.y"
{
		 yypvt[-2].P->next = yypvt[-0].P;
		 } break;
case 24:
# line 325 "pars.y"
{
		 yypvt[-2].P->next = yypvt[-0].P;
		 } break;
case 25:
# line 329 "pars.y"
{
		 yyerrok;
		 yypvt[-2].P->next = yypvt[-0].P;
		 } break;
case 29:
# line 340 "pars.y"
{
		 yypvt[-2].P->next = yypvt[-0].P;
		 } break;
case 30:
# line 344 "pars.y"
{
		 yypvt[-2].P->next = yypvt[-0].P;
		 } break;
case 31:
# line 348 "pars.y"
{
		 yyerrok;
		 yypvt[-2].P->next = yypvt[-0].P;
		 } break;
case 34:
# line 358 "pars.y"
{
		 if (yypvt[-0].P->sign == '+') poslitnr += 1;
		 if(yypvt[-0].P->symb<nrbuilt && yypvt[-0].P->sign == '+')
		 	nferror("Illegal usage of a built-in",yylineno);
		 } break;
case 35:
# line 364 "pars.y"
{
		 yypvt[-0].P->sign = (aktsign == '+')? '-' : '+';
		 if(yypvt[-0].P->symb<nrbuilt && yypvt[-0].P->sign == '+')
			nferror("Illegal usage of a built-in",yylineno);
		 if (yypvt[-0].P->sign == '+') poslitnr += 1;
		 yyval.P = yypvt[-0].P;
		 } break;
case 36:
# line 372 "pars.y"
{
		 tp = init_term(NULLTERM,yypvt[-2].N,VARIABLE,0,NGROUND);
		 tp->next = yypvt[-0].T;
		 yyval.P = init_pred(tp,IS_SYMB);
		 if (aktsign == '+')
		    nferror("Illegal usage of an assignment",yylineno);

		 VARUSAGE(tp);
		 } break;
case 37:
# line 382 "pars.y"
{
		 yypvt[-2].T->next = yypvt[-0].T;
		 yyval.P = init_pred(yypvt[-2].T,ASSI_SYMB);
		 if (aktsign == '+')
		    nferror("Illegal usage of an assignment",yylineno);
		 } break;
case 38:
# line 389 "pars.y"
{
		 yypvt[-2].T->next = yypvt[-0].T;
		 yyval.P = init_pred(yypvt[-2].T,EVAS_SYMB);
		 if (aktsign == '+')
		    nferror("Illegal usage of an assignment",yylineno);
		 } break;
case 40:
# line 400 "pars.y"
{
		 yyval.P = init_pred(NULLTERM,yypvt[-0].N);
		 if ((symbtab[yypvt[-0].N].name[0] == '$' && yyval.P->symb>=nrbuilt) ||
		     (symbtab[yypvt[-0].N].name[0] == '@' &&
		      symbtab[yypvt[-0].N].name[1] == '$' && yyval.P->symb>=nrbuilt)) {
		    nferror("Unknown built-in",yylineno);    
		 } else if ((symbtab[yypvt[-0].N].name[0] == '$') ||
			  (symbtab[yypvt[-0].N].name[0] == '@' &&
			   symbtab[yypvt[-0].N].name[1] == '$')) {
		   /* do not count builtins */
		   number_of_lits++;
		 }
                 if (ignorelits_flag == 1 && inwasm_flags.ignorelits) {
		   /* do not count ^Literals */
		   number_of_lits++;
		   yyval.P->literal_flag = 1;
		 } else if (subgoal_flag == 1) { 		  
		   yyval.P->subgoal_flag = 1;
		 }
		 subgoal_flag = 0;
		 ignorelits_flag = 0;
		 } break;
case 41:
# line 425 "pars.y"
{		
		 yyval.P = init_pred(yypvt[-1].T,yypvt[-4].N);
		 if ((symbtab[yypvt[-4].N].name[0] == '$' && yyval.P->symb>=nrbuilt) ||
		     (symbtab[yypvt[-4].N].name[0] == '@' &&
		      symbtab[yypvt[-4].N].name[1] == '$' && yyval.P->symb>=nrbuilt)) {
                    nferror("Unknown built-in",yylineno);
		 } else if ((symbtab[yypvt[-4].N].name[0] == '$') ||
			  (symbtab[yypvt[-4].N].name[0] == '@' &&
			   symbtab[yypvt[-4].N].name[1] == '$')) {
		   number_of_lits++;
                 } 
		 if (ignorelits_flag == 1 && inwasm_flags.ignorelits) {
		   number_of_lits++;
		   yyval.P->literal_flag = 1;
		 } else if (subgoal_flag == 1) { 		  
		   yyval.P->subgoal_flag = 1;
		 }
		 subgoal_flag = 0;
		 ignorelits_flag = 0;
		 if (max_termdepth > currclause->max_termdepth) 
		 	currclause->max_termdepth = max_termdepth;
		 if (termsize > currclause->max_termsize) 
		 	currclause->max_termsize = termsize;
		 termdepth=0;
		 max_termdepth=0;
		 termsize=0;
		 if (yypvt[-4].N == MKGLOB_SYMB)
		    enter_globarray(yyval.P->t_list);
		 } break;
case 43:
# line 459 "pars.y"
{
		 yypvt[-2].P->next = yypvt[-0].P;
		 } break;
case 44:
# line 466 "pars.y"
{
		 yypvt[-2].T->next = yypvt[-0].T;
		 yyval.P = init_pred(yypvt[-2].T,yypvt[-1].N);
		 yyval.P->litnr = ++nr_constraints;
		 yyval.P->claus = currclause;
		 yyval.P->sign = SEM_CONSTR;
		 } break;
case 46:
# line 478 "pars.y"
{
		 yypvt[-2].T->next = yypvt[-0].T;
		 } break;
case 47:
# line 482 "pars.y"
{
		 yypvt[-2].T->next = yypvt[-0].T;
		 } break;
case 48:
# line 486 "pars.y"
{
		 yyval.T = init_term(NULLTERM,0,CONSTANT,0,GROUND);
		 } break;
case 49:
# line 493 "pars.y"
{ 
		 termsize++;
		 if (max_termdepth < termdepth)
		 	max_termdepth = termdepth;
		 yyval.T = init_term(NULLTERM,yypvt[-0].N,VARIABLE,0,NGROUND);
		 VARUSAGE(yyval.T);
		 } break;
case 50:
# line 501 "pars.y"
{ 
		 termsize++;
		 if (max_termdepth < termdepth)
		 	max_termdepth = termdepth;
		 yyval.T = init_term(NULLTERM,yypvt[-0].N,NUMCONST,numval,GROUND);
		 } break;
case 51:
# line 508 "pars.y"
{ 
		 termsize++;
		 if (max_termdepth < termdepth)
		 	max_termdepth = termdepth;
		 yyval.T = init_term(NULLTERM,yypvt[-0].N,STRINGCONST,0,GROUND);
		 } break;
case 53:
# line 516 "pars.y"
{ /* only allowed in constraints => scan.l */
		 yyval.T = init_term(NULLTERM,yypvt[-0].N,SVARIABLE,0,NGROUND);
		 } break;
case 54:
# line 520 "pars.y"
{ 
		 termsize++;
		 if (max_termdepth < termdepth)
		 	max_termdepth = termdepth;
		 yyval.T = init_term(NULLTERM,yypvt[-0].N,CONSTANT,0,GROUND);
		 } break;
case 55:
# line 527 "pars.y"
{
		 termdepth--;
		 termsize++;
		 yyval.T = init_term(yypvt[-1].T,yypvt[-4].N,CONSTANT,0,GROUND);
		 } break;
case 56:
# line 533 "pars.y"
{ 
		 termdepth--;
		 termsize++;
		 yyval.T = init_term(yypvt[-1].T,HEAD_SYMB,CONSTANT,0,GROUND);
		 } break;
case 57:
# line 539 "pars.y"
{ 
		 termsize++;
		 if (max_termdepth < termdepth)
		 	max_termdepth = termdepth;
		 yyval.T = init_term(NULLTERM,NIL_SYMB,CONSTANT,0,GROUND);
		 } break;
case 58:
# line 549 "pars.y"
{ /* list ends with nil element */
		 yypvt[-0].T->next = init_term(NULLTERM,NIL_SYMB,CONSTANT,0,GROUND);
		 } break;
case 59:
# line 553 "pars.y"
{
		 yypvt[-2].T->next = init_term(yypvt[-0].T,HEAD_SYMB,CONSTANT,0,GROUND);
		 } break;
case 60:
# line 557 "pars.y"
{
		 yypvt[-2].T->next = yypvt[-0].T;
		 } break;
case 61:
# line 564 "pars.y"
{
		 yyval.T = init_term(yypvt[-1].T,-1,CONSTSYM,0,GROUND);
		 } break;
case 62:
# line 571 "pars.y"
{
		 termsize++;
		 if (max_termdepth < termdepth)
		 	max_termdepth = termdepth;
		 yyval.T = init_term(NULLTERM,yypvt[-0].N,GVARIABLE,0,NGROUND);
		 } break;
case 63:
# line 578 "pars.y"
{
		 termsize++;
		 if (max_termdepth < termdepth)
		 	max_termdepth = termdepth;
		 yyval.T = init_term(yypvt[-1].T,yypvt[-3].N,GVARIABLE,0,NGROUND);
		 } break;
case 64:
# line 588 "pars.y"
{ 
		 yyval.T = init_term(NULLTERM,yypvt[-0].N,NUMCONST,numval,GROUND);
		 } break;
case 65:
# line 592 "pars.y"
{ 
		 yyval.T = init_term(NULLTERM,yypvt[-0].N,VARIABLE,0,NGROUND);
		 VARUSAGE(yyval.T);
		 } break;
case 67:
# line 598 "pars.y"
{
		 yyval.T = yypvt[-1].T;
		 } break;
case 68:
# line 602 "pars.y"
{
		 yypvt[-2].T->next = yypvt[-0].T;
		 yyval.T = init_term(yypvt[-2].T,yypvt[-1].N,CONSTANT,0,GROUND);
		 } break;
case 69:
# line 607 "pars.y"
{
		 yypvt[-2].T->next = yypvt[-0].T;
		 yyval.T = init_term(yypvt[-2].T,yypvt[-1].N,CONSTANT,0,GROUND);
		 } break;
case 70:
# line 612 "pars.y"
{
		 yypvt[-2].T->next = yypvt[-0].T;
		 yyval.T = init_term(yypvt[-2].T,yypvt[-1].N,CONSTANT,0,GROUND);
		 } break;
case 71:
# line 617 "pars.y"
{
		 yypvt[-2].T->next = yypvt[-0].T;
		 yyval.T = init_term(yypvt[-2].T,yypvt[-1].N,CONSTANT,0,GROUND);
		 } break;
case 72:
# line 622 "pars.y"
{  /* dont use $<N>1 == MINUS_SYMB  */
		 yyval.T = init_term(yypvt[-0].T,UMI_SYMB,CONSTANT,0,GROUND);
		 } break;
case 73:
# line 626 "pars.y"
{
		 yyval.T = init_term(NULLTERM,0,CONSTANT,0,GROUND);
		 } break;
case 74:
# line 633 "pars.y"
{ /*  =<  <  >  >=  */
		 yypvt[-2].T->next = yypvt[-0].T;
		 yyval.P = init_pred(yypvt[-2].T,yypvt[-1].N);
		 } break;
case 75:
# line 638 "pars.y"
{
		  if (max_termdepth+1 > currclause->max_termdepth) 
		 	currclause->max_termdepth = max_termdepth+1;
		  termdepth=0;
		  max_termdepth=0;
		 } break;
case 76:
# line 645 "pars.y"
{ /* same operator for constraint =/= !! */
		 yypvt[-3].T->next = yypvt[-0].T;
		 yyval.P = init_pred(yypvt[-3].T,NQAL_SYMB);
		 if (max_termdepth+1 > currclause->max_termdepth) 
		 	currclause->max_termdepth = max_termdepth+1;
		 if (termsize > currclause->max_termsize) 
		 	currclause->max_termsize = termsize;
		 termdepth=0;
		 max_termdepth=0;
		 termsize=0;
		 } break;
case 77:
# line 657 "pars.y"
{
		  if (max_termdepth+1 > currclause->max_termdepth) 
		 	currclause->max_termdepth = max_termdepth+1;
		  termdepth=0;
		  max_termdepth=0;
		 } break;
case 78:
# line 664 "pars.y"
{
		 yypvt[-4].T->next = yypvt[-0].T;
		 yyval.P = init_pred(yypvt[-4].T,EQAL_SYMB);
		 if (max_termdepth+1 > currclause->max_termdepth) 
		 	currclause->max_termdepth = max_termdepth+1;
		 if (termsize > currclause->max_termsize) 
		 	currclause->max_termsize = termsize;
		 termdepth=0;
		 max_termdepth=0;
		 termsize=0;
		 } break;
case 79:
# line 676 "pars.y"
{
		  if (max_termdepth+1 > currclause->max_termdepth) 
		 	currclause->max_termdepth = max_termdepth+1;
		  termdepth=0;
		  max_termdepth=0;
		 } break;
case 80:
# line 683 "pars.y"
{
		 yypvt[-3].T->next = yypvt[-0].T;
		 yyval.P = init_pred(yypvt[-3].T,UNIF_SYMB);
		 if (max_termdepth+1 > currclause->max_termdepth) 
		 	currclause->max_termdepth = max_termdepth+1;
		 if (termsize > currclause->max_termsize) 
		 	currclause->max_termsize = termsize;
		 termdepth=0;
		 max_termdepth=0;
		 termsize=0;
		 } break;
case 81:
# line 697 "pars.y"
{ termdepth++;} break;
# line	531 "/usr/ccs/bin/yaccpar"
	}
	goto yystack;		/* reset registers in driver code */
}

