(define (display-clauses clauses)
 (if (pair? clauses)
     (begin (display-clause (car clauses))
            (display-clauses (cdr clauses)))))

(define (display-clause clause)
 (display "( ")
 (display-pos-literals (c-pos-literals clause))
 (display-neg-literals (c-neg-literals clause))
 (display ")") (newline))

(define (display-all-clauses clauses)
 (if (pair? clauses)
     (begin (display-all-clause (car clauses))
            (display-all-clauses (cdr clauses)))))

(define (display-all-clause clause)
 (display " ") (display (c-length clause))
 (display "( ")
 (display-pos-literals (c-pos-literals clause))
 (display-neg-literals (c-neg-literals clause))
 (display ")") 
 (if (c-activating-atom clause) 
     (display (a-name (c-activating-atom clause))))
 (newline))

(define (display-pos-literals atoms)
 (if (pair? atoms)
     (begin (display (a-name (car atoms))) (display " ")
            (display-pos-literals (cdr atoms)))))

(define (display-neg-literals atoms)
 (if (pair? atoms)
     (begin (display "-") (display (a-name (car atoms))) (display " ")
            (display-neg-literals (cdr atoms)))))

(define (display-atom-names atoms)
 (if (pair? atoms)
     (begin (display (a-name (car atoms))) (display " ")
            (display-atom-names (cdr atoms)))))

(define (display-atoms atoms)
 (if (pair? atoms)
     (begin ;(display "|")
            (display-atom (car atoms))
            (display-atoms (cdr atoms)))))

(define (display-atom atom)
 (display (a-name atom)) (display ": freq ")
 (display (a-pos-frequency atom)) (display " ")
 (display (a-neg-frequency atom))
 (newline) (display "pos: ") 
 (display-nr-clauses (a-pos-clauses atom))
 (newline) (display "neg: ") 
 (display "") (display "") 
 (display "")  
 (display "") (display "") (display "") (display "") 
 (display-nr-clauses (a-neg-clauses atom))
 (newline))

(define (display-nr-clauses clauses)
 (if (pair? clauses)
     (begin (display (c-number (car clauses))) (display " ")
            (display-nr-clauses (cdr clauses)))))
