(module semprop-main 
	(main call-semprop)    ;; this is the main procedure
	(import 
	 (semprop "semprop.scm"))
	)
      
(define (call-semprop argv) 
 (if (pair? (cdr argv)) 
     (semprop (cdr argv))
     (begin ; declaration of usage
(display 
"*** Usage: semprop <option>s <filename> *** ") 
(newline) (newline) (display
"<filename> must contain input <clause>s") 
(newline) (newline) (display
"Default syntax: <clause> ::= (I_1 ... I_n), any I_i an integer != 0")
(newline) (newline) (display
"Default model output: only the positive literals in model are displayed")
(newline) (newline) (display
"Default branching criterion: branches first to positive valuation except")
(newline) (display
"the literal occurs with a higher weight positively in the formula")
(newline) (newline) (display 
"<option>s:") 
(newline) (display
"-geninput:      switches to general syntax: <clause> ::= (<pos> <neg>) where")
(newline) (display 
"                <pos> and <neg> are lists of arbitrary scheme objects which")
(newline) (display 
"                denote the positive resp. negative literals in the clause")
(newline) (display
"-allmodels:     computes all models")
(newline) (display
"-noverbose:     only number of models displayed")
(newline) (display
"-verbose 0:     only number of models displayed")
(newline) (display
"-verbose 1:     only first model and number of models displayed")
(newline) (display
"-negmodel:      also negated literals in model displayed")
(newline) (display
"-neg:           branches always first to negative literal")
(newline) (display
"-pos:           branches always first to positive literal if -pos is off")
(newline) (display
"-div {0-6}:     different weight functions w: c clause, l length of c")
(newline) (display
"                div = i: w(c) = 1/(l^i), default is -div 3,")
(newline) (display
"                atom selection is acc. to maximal weight, atom weight is the")
(newline) (display
"                sum of the weights of the clauses in which the atom occurs")
(newline) (display
"-max:           atom weight is not sum but maximum of pos. and neg. weights") 
(newline) (display
"-dynamic:       dynamic atom selection wrt. current clause weights")
(newline) (display
"-maxdyn <NAT>:  from proper branch depth <NAT> on initial atom ordering used,")
(newline) (display
"                -dynamic is switched on")
(newline) (newline) (display
"General remarks: later options overwrite earlier ones")
(newline))))
