help( ["-h"|Arguments] ) :-
 	( member("tptpin", Arguments) ->
		help_tptpin
		;
		true
	),
 	( member("tptpout", Arguments) ->
		help_tptpout
		;
		true
	),
 	( member("verbose", Arguments) ->
		help_verbose
		;
		true
	),
 	( member("rmeqax", Arguments) ->
		help_rmeqax
		;
		true
	),
 	( member("demod", Arguments) ->
		help_demod
		;
		true
	),
 	( member("special", Arguments) ->
		help_special
		;
		true
	),
 	( member("stemod", Arguments) ->
		help_stemod
		;
		true
	),
 	( member("brandstemod", Arguments) ->
		help_brandstemod
		;
		true
	),
 	( member("moserstemod", Arguments) ->
		help_moserstemod
		;
		true
	),
 	( member("ceemod", Arguments) ->
		help_ceemod
		;
		true
	),
 	( member("sortfst", Arguments) ->
		help_sortfst
		;
		true
	),
 	( member("sortsnd", Arguments) ->
		help_sortsnd
		;
		true
	),
 	( member("umod", Arguments) ->
		help_umod
		;
		true
	),
 	( member("expose", Arguments) ->
		help_expose
		;
		true
	),
 	( member("rel", Arguments) ->
		help_rel
		;
		true
	),
 	( member("stat", Arguments) ->
		help_stat
		;
		true
	),
 	( member("sig", Arguments) ->
		help_sig
		;
		true
	),
 	( member("replnum", Arguments) ->
		help_replnum
		;
		true
	),
 	( member("rmod", Arguments) ->
		help_rmod
		;
		true
	),
 	( member("noquerytrans", Arguments) ->
		help_noquerytrans
		;
		true
	),
 	( member("addord", Arguments) ->
		help_addord
		;
		true
	),
 	( member("psetheo", Arguments) ->
		help_psetheo
		;
		true
	),
 	( member("split", Arguments) ->
		help_split
		;
		true
	),
 	( member("nosplitlits", Arguments) ->
		help_nosplitlits
		;
		true
	),
 	( member("nogroundsplit", Arguments) ->
		help_nogroundsplit
		;
		true
	),
 	( member("isol", Arguments) ->
		help_isol
		;
		true
	),
 	( member("ground", Arguments) ->
		help_ground
		;
		true
	),
        writeln( stderr, '***************************************************************************').
       

help_tptpin :-
        writeln( stderr, '******************************* Online Help tptpin ************************'),
        writeln( stderr, '*** Sets the type of the input file to tptp. Otherwise, lop format is'),
        writeln( stderr, '*** required').

help_tptpout :-
        writeln( stderr, '******************************* Online Help tptpout ***********************'),
        writeln( stderr, '*** Sets the type of the output file to tptp. Otherwise, the output is'),
        writeln( stderr, '*** given in lop format.').

help_verbose :-
        writeln( stderr, '******************************* Online Help verbose ***********************'),
        writeln( stderr, '*** This switch is responsible only for internal information.').

help_rmeqax :-
        writeln( stderr, '******************************* Online Help rmeqax ************************'),
        writeln( stderr, '*** This switch removes equality axioms from the input. Additional'),
        writeln( stderr, '*** arguments are'),
        writeln( stderr, '***     r   for removing reflexivity axioms,'),
        writeln( stderr, '***     s   for removing symmetry axioms,'),
        writeln( stderr, '***     t   for removing transitivity axioms and'),
        writeln( stderr, '***     e   for removing substitutivity axioms.'),
        writeln( stderr, '*** Without any arguments, -rmeqax corresponds to -rmeqax r s t e, i.e.'),
        writeln( stderr, '*** all equality axioms will be removed.').

help_demod :-
        writeln( stderr, '******************************* Online Help demod *************************'),
        writeln( stderr, '*** For each positive unit equation f(X_1,...,X_n) = t or a = t where'),
        writeln( stderr, '*** x_1,...,x_n are pairwise disjoint variables and a is a constant symbol,'),
        writeln( stderr, '*** each subterm of the form f(t_1,...,t_n) or a occurring in a clause is'),
        writeln( stderr, '*** reduced to the corresponding instantiated term t. Further, the positive'),
        writeln( stderr, '*** unit equations f(X_1,...,X_n) = t and a = t are removed.').

help_special :-
        writeln( stderr, '******************************* Online Help special ***********************'),
        writeln( stderr, '*** With this switch, variables on the right-hand side in specific witness'),
        writeln( stderr, '*** pairs generated by the STE-modification (see switches -stemod,'),
        writeln( stderr, '*** -moserstemod and -brandstemod) will be unified.'),
        writeln( stderr, '*** Obviously, this could lead to an incomplete strategy. This represents'),
        writeln( stderr, '*** the former STEXPOSU_NEW version of stexposu.').

help_stemod :-
        writeln( stderr, '******************************* Online Help stemod ************************'),
        writeln( stderr, '*** This switch applies Moser\'s STE-modification from the CADE-competition'),
        writeln( stderr, '*** CASC-14. Additional arguments are'),
        writeln( stderr, '***       s   for applying the S-modification,'),
        writeln( stderr, '***       t   for applying the T-modification and'),
        writeln( stderr, '***       e   for applying the E-modification.'),
        writeln( stderr, '*** Without any arguments, -stemod corresponds to the full'),
        writeln( stderr, '*** STE-modification, i.e. to -steomd s t e. Whenever -stemod is chosen,'),
        writeln( stderr, '*** the switch -rmeqax is activated, i.e. the equality axioms will be'),
        writeln( stderr, '*** removed. If the formula contains no equality, the STE-modification'),
        writeln( stderr, '*** will not be carried out.'),
        writeln( stderr, '*** The transformations are defined as follows:'),
        writeln( stderr, '***         S:  s=t v C  ==>  s=t v C'),
        writeln( stderr, '***             s=t v C  ==>  t=s v C'),
        writeln( stderr, '***         T:  s=t v C  ==>  s=Z v t=/=Z v C'),
        writeln( stderr, '***                   if t is not a variable and Z is a new variable'),
        writeln( stderr, '***         E:  X=/=Y v C  ==>  C + {X=Y}'),
        writeln( stderr, '***                   if X,Y are variables'),
        writeln( stderr, '***             s=/=t v C  ==>  s=/=Z v t=/=Z v C'),
        writeln( stderr, '***                   if t is not a variable'),
        writeln( stderr, '***             C(s)  ==>  C(Z) v s=/=Z'),
        writeln( stderr, '***                   where s contains at least 2 operators'),
        writeln( stderr, '***                         and Z is a new variable'),
        writeln( stderr, '***                         and this inference is applied only to'),
        writeln( stderr, '***                         left-hand sides (of equations)').

help_brandstemod :-
        writeln( stderr, '******************************* Online Help brandstemod *****************'),
        writeln( stderr, '*** With this switch, Brand\'s STE-modification is applied. In contrast to'),
        writeln( stderr, '*** Moser\'s STE-modification,'),
        writeln( stderr, '***     (i)  o positive equations with a variable as the right-hand side'),
        writeln( stderr, '***            must be split during T-modification.'),
        writeln( stderr, '***     (ii) o the root of the right-hand side in negative equations needs'),
        writeln( stderr, '***            not to be splitted, and'),
        writeln( stderr, '***          o it is necessary to perform inferences to left-hand sides of'),
        writeln( stderr, '***            negative equations of the form X=/=Y (where X,Y are'),
        writeln( stderr, '***            variables) during E-modification'),
        writeln( stderr, '*** Analogous with -stemod, s,t,e can be used as additional arguments of'),
        writeln( stderr, '*** brandstemod in order to apply the subtransformations.').

help_moserstemod :-
        writeln( stderr, '******************************* Online Help moserstemod *****************'),
        writeln( stderr, '*** With this switch Moser\'s (new) STE-modification is applied to a'),
        writeln( stderr, '*** formula. This modification allows to specify subtransformation in more'),
        writeln( stderr, '*** detail than with -stemod. Additional arguments are'),
        writeln( stderr, '***          s   for eliminating symmetry,'),
        writeln( stderr, '***          tp  for eliminating positive transitivity,'),
        writeln( stderr, '***          re  for partially eliminating reflexivity,'),
        writeln( stderr, '***          tn  for eliminating negative transitivity and'),
        writeln( stderr, '***          ml  for eliminating substitutivity (monotony) for'),
        writeln( stderr, '***              left-hand sides (of equations).'),
        writeln( stderr, '*** The subtransformations are defined as follows:'),
        writeln( stderr, '***          S:  identical to S of -stemod (see above)'),
        writeln( stderr, '***          Tp: identical to T of -stemod (see avove)'),
        writeln( stderr, '***          Re: X=/=Y v C  ==>  C + {X=Y}'),
        writeln( stderr, '***                    if X,Y are variables'),
        writeln( stderr, '***          Tn: s=/=t v C  ==>  s=/=Z v t=/=Z v C'),
        writeln( stderr, '***                    if t is not a variable'),
        writeln( stderr, '***          Ml: C(s)  ==>  C(Z) v s=/=Z'),
        writeln( stderr, '***                    where s contains at least 2 operators'),
        writeln( stderr, '***                          and Z is a new variable'),
        writeln( stderr, '***                          and this inference is applied only to'),
        writeln( stderr, '***                          left-hand sides (of equations)').

help_ceemod :-
        writeln( stderr, '******************************* Online Help ceemod ************************'),
        writeln( stderr, '*** With this switch the (STE-) modification of Bachmair, Ganzinger and'),
        writeln( stderr, '*** Voronkov is applied to a formula. Additional arguments are'),
        writeln( stderr, '***       m   for eliminating monotony (substitutivity),'),
        writeln( stderr, '***       re  for partially eliminating reflexivity,'),
        writeln( stderr, '***       s   for eliminating symmetry,'),
        writeln( stderr, '***       sn  for shifting variables of left-hand sides of negative'),
        writeln( stderr, '***           equations to right-hand sides,'),
        writeln( stderr, '***       tpc for eliminating positive transitivity introducing constraints'),
        writeln( stderr, '***           and'),
        writeln( stderr, '***       tnc for eliminating negative transitivity introducing constraints'),
        writeln( stderr, '*** Analogous with the other STE-modifications, -ceemod corresponds to an'),
        writeln( stderr, '*** application of the full CEE-modification. The subtransformation are'),
        writeln( stderr, '*** defined as follows:'),
        writeln( stderr, '***       M:  C(s)  ==>  C(Z) v s=/=Z'),
        writeln( stderr, '***                 if s contains at least 2 operators and Z is a new'),
        writeln( stderr, '***                 variable'),
        writeln( stderr, '***       Re: identical to Re of -moserstemod (see above),'),
        writeln( stderr, '***       S:  identical to S of -stemod (see above),'),
        writeln( stderr, '***       Sn: s=/=t v C  ==>  s=/=t v C'),
        writeln( stderr, '***                 if s is not a variable'),
        writeln( stderr, '***           X=/=t v C  ==>  t=/=X v C'),
        writeln( stderr, '***                 if X is a variable and t is not a variable'),
        writeln( stderr, '***       Tpc: (s=t v C).A  ==>  (s=Z v t=/=Z v C).(A ^ s>Z ^ t>=Z)'),
        writeln( stderr, '***                 if t is not a variable'),
        writeln( stderr, '***       Tnc: (s=/=t v C).A  ==> (s=/=Z v t=/=Z v C).(A ^ s>=Z ^ t>=Z)'),
        writeln( stderr, '***                 if t is not a variable and Z is a new variable').

help_sortfst :-
        writeln( stderr, '******************************* Online Help sortfst ***********************'),
        writeln( stderr, '*** In connection with the switches -moserstemod, -brandstemod and'),
        writeln( stderr, '*** -ceemod, the switch -sortfst <Op> ignores the transformation of the'),
        writeln( stderr, '*** sort operator <Op> which contains the sort information as its first'),
        writeln( stderr, '*** argument (see also the switch -sortsnd).'),
        writeln( stderr, '*** For example, transforming the equation'),
        writeln( stderr, '***          sort([univ],f(a,sort([bool],X))) = g(sort([nat],b))'),
        writeln( stderr, '*** without -sortfst, the STE-modification will be applied to each of the'),
        writeln( stderr, '*** operators sort. Whenever -sortfst sort is chosen, only the operators'),
        writeln( stderr, '*** f,a,g,b are transformed. Note that with -sortfst, also mixed terms can'),
        writeln( stderr, '*** be dealt with (i.e. specific subterms may contain sort information,'),
        writeln( stderr, '*** other subterms need not contain sort information).'),
        writeln( stderr, '*** For different sort operators op_1,...,op_n, the switches'),
        writeln( stderr, '***    -sortfst op_1 -sortfst op_2 ... -sortfst op_n'),
        writeln( stderr, '*** must be used').

help_sortsnd :-
        writeln( stderr, '******************************* Online Help sortsnd ***********************'),
        writeln( stderr, '*** Analogous with -sortfst, this switch is used to ignore the'),
        writeln( stderr, '*** transformation of sort operators. In contrast to -sortfst, the sort'),
        writeln( stderr, '*** information for -sortsnd is specified as the second argument.'),
        writeln( stderr, '*** Note that the sets of operators for -sortfst and -sortsnd must be'),
        writeln( stderr, '*** disjoint! I.e., -sortfst f -sortsnd f is not allowed.').

help_umod :-
        writeln( stderr, '******************************* Online Help umod **************************'),
        writeln( stderr, '*** With this switch, a formula is U-modified, i.e. specific clauses which'),
        writeln( stderr, '*** have been extended with negative equations during STE-modification,'),
        writeln( stderr, '*** will be added unchanged to the output. Without any further arguments,'),
        writeln( stderr, '*** this action will be applied only to unit clauses. With the switch'),
        writeln( stderr, '*** -umod NUMBER, clauses with a length up to NUMBER, will be added.').

help_expose :-
        writeln( stderr, '******************************* Online Help expose ************************'),
        writeln( stderr, '*** With ths switch, clauses containing more than 2 positive equations will'),
        writeln( stderr, '*** be splitted into clauses containing at most one positive equation. For'),
        writeln( stderr, '*** a=b v c=d v e=f will be transformed into'),
        writeln( stderr, '*** 		  l1 v l2 v l3'),
        writeln( stderr, '*** 		  a=b v not(l1)'),
        writeln( stderr, '*** 		  c=d v not(l2)'),
        writeln( stderr, '*** 		  e=f v not(l3)').

help_rel :-
        writeln( stderr, '******************************* Online Help rel ***************************'),
        writeln( stderr, '*** With this switch the so-called relevance transformation is performed,'),
        writeln( stderr, '*** i.e., if the input formula contains at least one pure negative axiom'),
        writeln( stderr, '*** or a negative hypothesis, then in the lop output file there is at'),
        writeln( stderr, '*** least one literal before the <- sign for each axiom and hypothesis,'),
        writeln( stderr, '*** and there is nothing before <- in the case of a conjecture.').

help_stat :-
        writeln( stderr, '******************************* Online Help stat **************************'),
        writeln( stderr, '*** With this switch, several lines of comment are added at the beginning'),
        writeln( stderr, '*** of the outpu file containing statistic information about the formula.'),
        writeln( stderr, '*** These data are formatted as the headers in tptp files.').

help_sig :-
        writeln( stderr, '******************************* Online Help sig ***************************'),
        writeln( stderr, '*** With this switch, the BIP $sig([...]) is added to each clause where the'),
        writeln( stderr, '*** list contains all predicate and function symbols occurring in the'),
        writeln( stderr, '*** clause. Furthermore, a clause is added (which can be deleted by purity)'),
        writeln( stderr, '*** at the beginning of the output file containing the full signature of'),
        writeln( stderr, '*** the formula together with the arities of the symbols.'),
        writeln( stderr, '*** With -sig c/-sig h/-sig c h, a list of predicate and function symbols'),
        writeln( stderr, '*** for conjectures/hypotheses/conjectures+hypotheses can be constructed.'),
        writeln( stderr, '*** With d as argument of -sig, the list contains each symbol as often'),
        writeln( stderr, '*** as it occurs in the clause.').

help_replnum :-
        writeln( stderr, '******************************* Online Help replnum ***********************'),
        writeln( stderr, '*** With this switch, numbers in clauses are replaced by respective atoms,'),
        writeln( stderr, '*** i.e. each number NO is replaced with number__NO__.').

help_rmod :-
        writeln( stderr, '******************************* Online Help rmod **************************'),
        writeln( stderr, '*** Mit -rmod wird die beschraenkte R-Modifikation durchgefuehrt. Konkret'),
        writeln( stderr, '*** bedeutet dies, dass bei Angabe einer positiven Zahl N zu jeder Klausel'),
        writeln( stderr, '*** mit negierten Gleichungen (z.B. aus der STE-Modifikation) alle durch'),
        writeln( stderr, '*** Reflektion daraus erzeugbaren Klauseln hinzugefuegt werden, die noch'),
        writeln( stderr, '*** genau N negative Gleichungen besitzen. Durch die Angabe eines negativen'),
        writeln( stderr, '*** Werts -N werden alle Klauseln erzeugt, die durch Reflektion aus der'),
        writeln( stderr, '*** Ausgangsklausel erzeugbar sind, und die noch BIS ZU N negative'),
        writeln( stderr, '*** Gleichungen enthalten.').

help_noquerytrans :-
        writeln( stderr, '******************************* Online Help noquerytrans ******************'),
        writeln( stderr, '*** Ignores the application of the switches -stemod, -moserstemod,'),
        writeln( stderr, '*** -brandstemod, -ceemod, -umod, -rmod and -expose to pure negative'),
        writeln( stderr, '*** clauses (i.e., to conjectures).').

help_addord :-
        writeln( stderr, '******************************* Online Help addord ************************'),
        writeln( stderr, '*** With this switch, LPO ordering built ins (constraints) for positive'),
        writeln( stderr, '*** equations are added.'),
        writeln( stderr, '*** A heuristic-based approach for generating an appropriate LPO-precedence'),
        writeln( stderr, '*** adds an ordering on operators (which can be deleted by purity) at the'),
        writeln( stderr, '*** beginning of the output file.').

help_psetheo :-
        writeln( stderr, '******************************* Online Help psetheo ***********************'),
        writeln( stderr, '*** In combination with the switch -sig (or -addord), the state of the'),
        writeln( stderr, '*** set of clauses will be returned before applying -sig (-addord).'),
        writeln( stderr, '*** The two clause sets will be separated from each other by'),
        writeln( stderr, '*** =============================================.').

help_split :-
        writeln( stderr, '******************************* Online Help split *************************'),
        writeln( stderr, '*** Does clause splitting according to the Letz method. Beginning with the'),
        writeln( stderr, '*** conjectures of the problem, clauses are split into lists of clauses'),
        writeln( stderr, '*** with disjoint sets of variables. To preserve correctness, additional'),
        writeln( stderr, '*** split literals are added to those lists. This filter is triggered by'),
        writeln( stderr, '*** the command line switch -split Count.'),
        writeln( stderr, '*** To avoid flooding the problem with split clauses a limit for the number'),
        writeln( stderr, '*** of initial clauses splitted can be specified by Count. A Count of 0'),
        writeln( stderr, '*** (or a negative Count) implies no limit.'),
        writeln( stderr, '*** see also -nosplitlits, -nogroundsplit').

help_nosplitlits :-
        writeln( stderr, '******************************* Online Help nosplitlits *******************'),
        writeln( stderr, '*** The switch -nosplitlits prevents the split literals (see switch -split)'),
        writeln( stderr, '*** from being added to the output, WHICH ARE NECESSARY TO MAINTAIN'),
        writeln( stderr, '*** CORRECTNESS, but who are a pain in the neck if any kind of'),
        writeln( stderr, '*** postprocessing is planned.').

help_nogroundsplit :-
        writeln( stderr, '******************************* Online Help nogroundsplit ******************'),
        writeln( stderr, '*** The switch -nogroundsplit [0|1|2] inhibits ground literals from being'),
        writeln( stderr, '*** split off (see switch -split). The optional argument concerns the way'),
        writeln( stderr, '*** ground literals will be treated:'),
        writeln( stderr, '***    0 All ground literals from a clause will form one subclause.'),
        writeln( stderr, '***    1 A more intelligent version of 0; if there is only one ground'),
        writeln( stderr, '***      literal in the clause, no extra subclause will be generated, the'),
        writeln( stderr, '***      literal will be attached to the first subclause. This prevents the'),
        writeln( stderr, '***      craetion of unnecessary split literals. Otherwise like option 0.'),
        writeln( stderr, '***    2 All ground literals are attached to the first subclause. This'),
        writeln( stderr, '***      option creates the fewest split literals.'),
        writeln( stderr, '*** This optional argument defaults to 1.').

help_isol :-
        writeln( stderr, '******************************* Online Help isol **************************'),
        writeln( stderr, '*** This filter performs some basic simplifying for a certain class of'),
        writeln( stderr, '*** problems. If a conjecture c contains a literal p that has only one'),
        writeln( stderr, '*** connection --p to the rest of the formula (p and --p can be unified),'),
        writeln( stderr, '*** then p is replaced by the rest of the clause containing --p and the'),
        writeln( stderr, '*** unifier of p and --p is applied to the newly formed c1.').

help_ground :-
        writeln( stderr, '******************************* Online Help ground ************************'),
        writeln( stderr, '*** This filter performs grounding for a small number of problems. These'),
        writeln( stderr, '*** problems must fulfill the following conditions:'),
        writeln( stderr, '***   - all existing function symbols are of arity 0 (i.e. constants)'),
        writeln( stderr, '***   - the Herbrand universe of that problem must be very finite (i.e.'),
        writeln( stderr, '***     sufficiently small).'),
        writeln( stderr, '*** This filter works by replacing each non-ground clause with all possible'),
        writeln( stderr, '*** ground instantiations for that clause. It is obvious that this can only'),
        writeln( stderr, '*** work with sufficiently small Herbrand models AND a small number of free'),
        writeln( stderr, '*** variables per clause to avoid an explosion of the number of ground'),
        writeln( stderr, '*** clauses created.'),
        writeln( stderr, '*** This filter can be invoked with an additional argument:'),
        writeln( stderr, '***         -ground NoClauses'),
        writeln( stderr, '*** where NoClauses is the maximum number of constants the signature of the'),
        writeln( stderr, '*** problem may contain. A negative number or zero implies no limit. If'),
        writeln( stderr, '*** there are more constants than NoConst or there are proper function'),
        writeln( stderr, '*** symbols, no grounding will take place. When this filter is invoked'),
        writeln( stderr, '*** without the additional argument, a limit of 30000 ground clauses is'),
        writeln( stderr, '*** assumed.').
