%###########################################################################
%# eqax.pl
%# - test for equality axioms and return set of positive unit equations
%###########################################################################
%#        Max Moser                         Automated Reasoning Research Group
%# Email: moser@informatik.tu-muenchen.de     Lehrstuhl VIII f"ur Informatik
%# Tel.:  +49-89/521096			     Technische Universit"at M"unchen
%# Fax.:  +49-89/526502			         D-80290 M"unchen, Germany
%# http://wwwjessen.informatik.tu-muenchen.de/~moser
%###########################################################################

:- lib(lists).

:- op(100,fx,++).
:- op(100,fx,--).


%*****************************************************************************
%* test4eq( +ClauseList, -UnitEqs )
%*****************************************************************************
%* - find out whether ClauseList contains equality literals
%* - return set of unit equations
%*****************************************************************************

test4eq( ClauseList, PosUnitEqs ) :-
	test4eq( ClauseList, noeqs, PosUnitEqs ).


test4eq( [], noeqs, [] ) :-
	!,
	retract_all(cmd_arg(rmeqax)),
	retract_all(cmd_arg(stemod)),
	retract_all(cmd_arg(smod)),
	retract_all(cmd_arg(temod)),
	retract_all(cmd_arg(umod)),
	retract_all(cmd_arg(expos)),
	retract_all(cmd_arg(addord)).
	% writeln(error,'*** no equality found, no modifications').

test4eq( [], eqs, [] ).

test4eq( [clause(_,_,[++equal(L,R)],_,_)|RestClauses], _, [[L,R]|RestPosUnitEqs] ) :-
	!,
	test4eq( RestClauses, eqs, RestPosUnitEqs ).

test4eq( [_|RestClauses], eqs, PosUnitEqs ) :-
	!,
	test4eq( RestClauses, eqs, PosUnitEqs ).

test4eq( [clause(_,_,LitList,_,_)|RestClauses], noeqs, PosUnitEqs ) :-
	member( ++equal(_,_), LitList ),
	!,
	test4eq( RestClauses, eqs, PosUnitEqs ).

test4eq( [_|RestClauses], EqOrNot, PosUnitEqs ) :-
	test4eq( RestClauses, EqOrNot, PosUnitEqs ).

%*****************************************************************************

