
























%{


#include "wasm.h"
#include "parser.h"
#include "tags.h"







typedef union {
        struct {
        int	val;		
        short	tag;		
        } EXPRVAL;
        } YYSTYPE;


	
static	char            eqtoken[TOKENLENGTH];
	
static	int		optim = 0;
	
static	int		defval;
int   yylex();
extern char yytext[];
%}



%token LABEL NL 
%token NUMBER
%token EQU DW DS START ORG 
%token OPTIM NOOPT INCLUDE
%token CLAUSE RED
%token SYMB PRED STRING 



%token TVOID TVAR TCONST TGLOBAL TGTERM TNGTERM TCSTRVAR
%token TCREF TEOSTR TCRTERM







%token T_i_alloc
%token T_i_nalloc
%token T_i_dealloc
%token T_i_ndealloc
%token T_i_fold_up
%token T_i_reg_fold_up
%token T_i_call
%token T_i_stop
%token T_i_break
%token T_i_jmp
%token T_i_jmpz
%token T_i_jmpg
%token T_i_unvoid
%token T_i_unconst
%token T_i_unvar
%token T_i_ungterm
%token T_i_unngterm
%token T_i_unglobl
%token T_i_orbranch
%token T_i_porbranch
%token T_i_fail
%token T_i_reduct
%token T_i_ureduct
%token T_i_proceed
%token T_i_add
%token T_i_mul
%token T_i_sub
%token T_i_div
%token T_i_lod
%token T_i_sto
%token T_i_glod
%token T_i_gsto
%token T_i_lconst
%token T_i_assign
%token T_i_genreg
%token T_i_genxreg
%token T_i_genureg
%token T_i_cgen
%token T_i_ptree
%token T_i_out
%token T_i_tell
%token T_i_told
%token T_i_eqpred
%token T_i_eq_built
%token T_i_neq_built
%token T_i_equ_unif
%token T_i_isunifiable
%token T_i_isnotunifiable
%token T_i_pre_cut
%token T_i_cut
%token T_i_is_var
%token T_i_is_nonvar
%token T_i_is_number
%token T_i_is_const
%token T_i_is_compl
%token T_i_rand_reorder
%token T_i_setrand
%token T_i_galloc
%token T_i_size
%token T_i_tdepth
%token T_i_getdepth
%token T_i_getinf
%token T_i_getmaxinf
%token T_i_getlocinf
%token T_i_set_depth
%token T_i_set_inf
%token T_i_set_maxinf
%token T_i_set_locinf
%token T_i_functor
%token T_i_arg
%token T_i_genlemma
%token T_i_genulemma
%token T_i_checklemma
%token T_i_checkulemma
%token T_i_addtoindex
%token T_i_checkindex
%token T_i_uselemma
%token T_i_dumplemma
%token T_i_getnrlemmata
%token T_i_delrange
%token T_i_path2list
%token T_i_assume
%token T_i_init_counters
%token T_i_getcounter
%token T_i_set_counter
%token T_i_get_maxfvars
%token T_i_set_maxfvars
%token T_i_get_maxtc
%token T_i_set_maxtc
%token T_i_get_maxsgs
%token T_i_set_maxsgs
%token T_i_lpo
%token T_i_lpoeq
%token T_i_kbo
%token T_i_sig
%token T_i_precall
%token T_i_isempty
%token T_i_issubset
%token T_i_ismember
%token T_i_card
%token T_i_mkempty
%token T_i_addtoset
%token T_i_remfromset
%token T_i_selnth
%token T_i_selnext
%token T_i_postunify
%token T_i_argsize
%token T_i_preunify
%token T_i_array_assign
%token T_i_array_glod
%token T_i_array_gsto




%type <EXPRVAL> expr numexpr symbtype


%left '+' '-'

%%
program : line 
	| program line
        ;

line    : NL 
        | '.' directive NL
	| '.' INCLUDE STRING NL
		{ if (incl_ptr == MAX_INCL -1) {
			nferror("Illegal nesting of include files");
			exit(1);
		  }
		  if ((infiles[incl_ptr+1] = fopen(token,"r")) == NULL) {
			nferror("could not open include file");
			fprintf(stderr,"File name: %s\n",token);
		  }
		  else {
			;
			yyin = infiles[++incl_ptr];
		  }
		}
        | LABEL ':' NL 
                { 
		  if (optim) {
			
			if (getdef(token,ISLABEL,&defval) == UNDEF) 
				o_name(defval,UNDEF);
			else
				o_name(defval,VALUE);
		  }
		  else {
			
                	if (putdef(token,ISLABEL,curr_pc)) {
                        	nferror("Label multiply defined");
                        	prttoken(token);
                       	}
		  }
                }
        | statement NL 
		{ optim = 0; 
		}

        | error NL 
                { errors++; 
		}   
        ;


statement :




	 T_i_alloc  expr 
		{ put_instr(0,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_nalloc  expr 
		{ put_instr(1,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_dealloc 
		{ put_instr(2,curr_pc++);
		}
	|  T_i_ndealloc 
		{ put_instr(3,curr_pc++);
		}
	|  T_i_fold_up 
		{ put_instr(4,curr_pc++);
		}
	|  T_i_reg_fold_up 
		{ put_instr(5,curr_pc++);
		}
	|  T_i_call 
		{ put_instr(6,curr_pc++);
		}
	|  T_i_stop 
		{ put_instr(7,curr_pc++);
		}
	|  T_i_break 
		{ put_instr(8,curr_pc++);
		}
	|  T_i_jmp  expr 
		{ put_instr(9,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_jmpz  expr 
		{ put_instr(10,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_jmpg  expr 
		{ put_instr(11,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_unvoid  expr 
		{ put_instr(12,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_unconst  expr 
		{ put_instr(13,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_unvar  expr 
		{ put_instr(14,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_ungterm  expr 
		{ put_instr(15,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_unngterm  expr 
		{ put_instr(16,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_unglobl  expr 
		{ put_instr(17,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_orbranch  expr 
		{ put_instr(18,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_porbranch  expr ','  expr ','  expr 
		{ put_instr(19,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		put_oper($4.val,$4.tag,curr_pc++);
		put_oper($6.val,$6.tag,curr_pc++);
		}
	|  T_i_fail 
		{ put_instr(20,curr_pc++);
		}
	|  T_i_reduct  expr ','  expr 
		{ put_instr(21,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		put_oper($4.val,$4.tag,curr_pc++);
		}
	|  T_i_ureduct  expr ','  expr 
		{ put_instr(22,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		put_oper($4.val,$4.tag,curr_pc++);
		}
	|  T_i_proceed 
		{ put_instr(23,curr_pc++);
		}
	|  T_i_add 
		{ put_instr(24,curr_pc++);
		}
	|  T_i_mul 
		{ put_instr(25,curr_pc++);
		}
	|  T_i_sub 
		{ put_instr(26,curr_pc++);
		}
	|  T_i_div 
		{ put_instr(27,curr_pc++);
		}
	|  T_i_lod  expr 
		{ put_instr(28,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_sto  expr 
		{ put_instr(29,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_glod  expr 
		{ put_instr(30,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_gsto  expr 
		{ put_instr(31,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_lconst  expr 
		{ put_instr(32,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_assign  expr ','  expr 
		{ put_instr(33,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		put_oper($4.val,$4.tag,curr_pc++);
		}
	|  T_i_genreg  expr 
		{ put_instr(34,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_genxreg  expr 
		{ put_instr(35,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_genureg  expr 
		{ put_instr(36,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_cgen  expr 
		{ put_instr(37,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_ptree 
		{ put_instr(38,curr_pc++);
		}
	|  T_i_out  expr 
		{ put_instr(39,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_tell  expr 
		{ put_instr(40,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_told 
		{ put_instr(41,curr_pc++);
		}
	|  T_i_eqpred  expr ','  expr ','  expr 
		{ put_instr(42,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		put_oper($4.val,$4.tag,curr_pc++);
		put_oper($6.val,$6.tag,curr_pc++);
		}
	|  T_i_eq_built  expr 
		{ put_instr(43,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_neq_built  expr 
		{ put_instr(44,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_equ_unif  expr 
		{ put_instr(45,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_isunifiable  expr 
		{ put_instr(46,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_isnotunifiable  expr 
		{ put_instr(47,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_pre_cut 
		{ put_instr(48,curr_pc++);
		}
	|  T_i_cut 
		{ put_instr(49,curr_pc++);
		}
	|  T_i_is_var  expr 
		{ put_instr(50,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_is_nonvar  expr 
		{ put_instr(51,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_is_number  expr 
		{ put_instr(52,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_is_const  expr 
		{ put_instr(53,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_is_compl  expr 
		{ put_instr(54,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_rand_reorder 
		{ put_instr(55,curr_pc++);
		}
	|  T_i_setrand  expr 
		{ put_instr(56,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_galloc  expr 
		{ put_instr(57,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_size  expr 
		{ put_instr(58,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_tdepth  expr 
		{ put_instr(59,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_getdepth  expr 
		{ put_instr(60,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_getinf  expr 
		{ put_instr(61,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_getmaxinf  expr 
		{ put_instr(62,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_getlocinf  expr 
		{ put_instr(63,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_set_depth  expr 
		{ put_instr(64,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_set_inf  expr 
		{ put_instr(65,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_set_maxinf  expr 
		{ put_instr(66,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_set_locinf  expr 
		{ put_instr(67,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_functor  expr 
		{ put_instr(68,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_arg  expr 
		{ put_instr(69,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_genlemma  expr 
		{ put_instr(70,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_genulemma  expr ','  expr 
		{ put_instr(71,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		put_oper($4.val,$4.tag,curr_pc++);
		}
	|  T_i_checklemma  expr 
		{ put_instr(72,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_checkulemma  expr ','  expr 
		{ put_instr(73,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		put_oper($4.val,$4.tag,curr_pc++);
		}
	|  T_i_addtoindex  expr 
		{ put_instr(74,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_checkindex  expr 
		{ put_instr(75,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_uselemma  expr 
		{ put_instr(76,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_dumplemma 
		{ put_instr(77,curr_pc++);
		}
	|  T_i_getnrlemmata  expr 
		{ put_instr(78,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_delrange  expr 
		{ put_instr(79,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_path2list  expr 
		{ put_instr(80,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_assume 
		{ put_instr(81,curr_pc++);
		}
	|  T_i_init_counters  expr 
		{ put_instr(82,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_getcounter  expr 
		{ put_instr(83,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_set_counter  expr 
		{ put_instr(84,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_get_maxfvars  expr 
		{ put_instr(85,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_set_maxfvars  expr 
		{ put_instr(86,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_get_maxtc  expr 
		{ put_instr(87,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_set_maxtc  expr 
		{ put_instr(88,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_get_maxsgs  expr 
		{ put_instr(89,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_set_maxsgs  expr 
		{ put_instr(90,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_lpo  expr 
		{ put_instr(91,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_lpoeq  expr 
		{ put_instr(92,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_kbo  expr 
		{ put_instr(93,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_sig  expr 
		{ put_instr(94,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_precall 
		{ put_instr(95,curr_pc++);
		}
	|  T_i_isempty  expr 
		{ put_instr(96,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_issubset  expr 
		{ put_instr(97,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_ismember  expr 
		{ put_instr(98,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_card  expr 
		{ put_instr(99,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_mkempty  expr 
		{ put_instr(100,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_addtoset  expr 
		{ put_instr(101,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_remfromset  expr 
		{ put_instr(102,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_selnth  expr 
		{ put_instr(103,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_selnext  expr 
		{ put_instr(104,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_postunify  expr 
		{ put_instr(105,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_argsize  expr ','  expr 
		{ put_instr(106,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		put_oper($4.val,$4.tag,curr_pc++);
		}
	|  T_i_preunify  expr 
		{ put_instr(107,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_array_assign  expr 
		{ put_instr(108,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_array_glod  expr 
		{ put_instr(109,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
	|  T_i_array_gsto  expr 
		{ put_instr(110,curr_pc++);
		put_oper($2.val,$2.tag,curr_pc++);
		}
        ;

directive :  
        EQU LABEL 
                { strcpy(eqtoken,token);
                }
        numexpr 
                { 
                  if (putdef(eqtoken,ISEQU,$4.val)) {
                        nferror("EQU name multiply defined");
                        prttoken(eqtoken);
                  }
                }
        | DW exprlist 
        | DS numexpr 
                { 
		  if ($2.tag == UNDEF)
			nferror(".ds numexpr: numexpr must be defined");
		  else
                	curr_pc += $2.val;
                }
        | START 
                { 
                  enter_start(curr_pc);
                }
        | ORG  numexpr
                { 
		  if ($2.tag == UNDEF)
			nferror(".org numexpr: numexpr must be defined");
		  else
                	curr_pc = $2.val;
                }
	| SYMB STRING 
                { codestr(eqtoken,token);
		}
	  ',' symbtype ',' numexpr
		{ 
		put_symbol_code($5.val,$7.val,eqtoken);
		
		}

	| CLAUSE numexpr ',' numexpr
		{ 
		  if ($2.tag == UNDEF || $4.tag == UNDEF)
			nferror(".clause: numexpr must be defined");
		  put_clause_code($2.val,$4.val);
		}
	| RED numexpr
		{ 
		  if ($2.tag == UNDEF )
			nferror(".reduct: numexpr must be defined");
		  put_reduct_code($2.val);
		}
	| OPTIM
		{ if (optflg)
			optim = 1;
		}
	| NOOPT
		{ if (optim) 
			list2tree();
		  optim = 0;
		}

        ;

symbtype: PRED
		{ $$.val = SYMB_P;
		}
	| TVAR
		{ $$.val = SYMB_V;
		}
	| TCONST
		{ $$.val = SYMB_C;
		}
	| TGLOBAL
		{ $$.val = SYMB_GLOBAL;
		}
	| TGTERM
		{ $$.val = SYMB_F;
		}
	| TNGTERM
		{ $$.val = SYMB_F;
		}
	;


exprlist: datexpr
        | exprlist ',' datexpr
        ;

datexpr : numexpr 
                { if (optim){
			enter_opt($1.val,$1.tag);
		  }
		  else
                	put_tag_word(curr_pc++,$1.val,$1.tag,0);
                }





        | TCREF numexpr
                { put_tag_word(curr_pc++,$2.val,$2.tag,T_CREF);
                }
        | TEOSTR numexpr
                { put_tag_word(curr_pc++,$2.val,$2.tag,T_EOSTR);
                }
        | TCONST numexpr
                { put_tag_word(curr_pc++,$2.val,$2.tag,T_CONST);
                }
        | TVAR numexpr
                { put_tag_word(curr_pc++,$2.val,$2.tag,T_VAR);
                }
        | TGTERM numexpr
                { put_tag_word(curr_pc++,$2.val,$2.tag,T_GTERM);
                }
        | TGLOBAL numexpr
                { put_tag_word(curr_pc++,$2.val,$2.tag,T_HREF);
                }
        | TNGTERM numexpr
                { put_tag_word(curr_pc++,$2.val,$2.tag,T_NGTERM);
                }
        | TCRTERM numexpr
                { put_tag_word(curr_pc++,$2.val,$2.tag,T_CRTERM);
                }
        | TCSTRVAR numexpr
                { put_tag_word(curr_pc++,$2.val,$2.tag,T_CSTRVAR);
                }
        ;

expr    : LABEL 
                { 
                  if (getdef(token,ISLABEL,&defval) == UNDEF) {
                        $$.tag = UNDEF;
                  }
                  else { 
                        $$.tag = VALUE;
                  }
                  $$.val = defval;
                }
        | NUMBER 
                { $$.tag = VALUE;
                  $$.val = numval;
                }
        ;

numexpr : NUMBER 
                { 
                  $$.tag = VALUE;
                  $$.val = numval;
                }       
        | LABEL 
                { 
                  if (getdef(token,ISLABEL,&defval) == UNDEF) {
                	$$.val = defval;
                        $$.tag = UNDEF;
                  }
                  else {
                        $$.val = defval;
                        $$.tag = VALUE;
                  }
                }
        | numexpr '+' numexpr
                { 
                  if (($1.tag == UNDEF) || ($3.tag == UNDEF)) {
                        warning("sum: undefined values: 0 taken");
                        $$.val = 0;
                        $$.tag = UNDEF;
                  }
                  else {
                        $$.val = $1.val + $3.val;
                        $$.tag = VALUE;
                  }
                }
        | numexpr '-' numexpr 
                { 
                  if (($1.tag == UNDEF) || ($3.tag == UNDEF)) {
                        warning("minus: undefined values: 0 taken");
                        $$.val = 0;
                        $$.tag = UNDEF;
                  }
                  else {
                        $$.val = $1.val - $3.val;
                        $$.tag = VALUE;
                  }
                }
        ;


        
%%









void yyerror ()

{ 


    fprintf (stderr,"Syntax error occurred in line : %d\n", yylineno);
    fprintf(stderr,"near token %s\n",yytext);
    errors++;

} 














int yywrap ()

{ 


	
    if (incl_ptr > 0) {
 	
	fclose (yyin);
 	
	incl_ptr--;
	yyin = infiles[incl_ptr];
	
	return 0;
    }

    return 1;

}




